<?php


/**
 * Admin form
 *
 * @ingroup forms
 */
function geomap_admin_form() {
  //even if a user has permission to view the information, they need access to update it
  $permission_to_update = user_access('administer geomap');

  $path_to_module = base_path() . drupal_get_path('module', 'geomap');
  $custom = _geomap_render_override_admin_display();

  $altitude_options = array();
  for ($i = 0; $i < 14; $i++) {

  }

  $form = array();

  $group_weight = -99;

  //general information for module
  $form['overrides'] = array(
    '#type' => 'fieldset',
    '#weight' => $group_weight++,
    '#title' => t('File Overrides'),
    '#collapsible' => TRUE,
    '#collapsed' => FALSE,
    '#description' => t('Place the Geomap .js or .css files in !directory on your server to override the original. These files will not be overwritten when Geomap is updated. Changes to the original file must be added to these files by hand.', array(
      '!directory' => $path_to_module . '/custom'
    )),


  );

  $form['overrides']['list'] = array(
    '#weight' => $group_weight++,
    '#value' => $custom,


  );

  $form['googlemap_domains_keys'] = array(
    '#type' => 'fieldset',
    '#weight' => $group_weight++,
    '#title' => t('Registered Google Map API Keys'),
    '#collapsible' => TRUE,
    '#collapsed' => FALSE,


  );

  $form['googlemap_domains_keys']['set_pairs'] = array(
    '#type' => 'fieldset',
    '#weight' => $group_weight++,
    '#collapsible' => FALSE,
    '#description' => _get_domain_keys(),


  );

  $form['googlemap_domains_keys']['add_pair'] = array(
    '#type' => 'fieldset',
    '#weight' => $group_weight++,
    '#collapsible' => FALSE,
    '#description' => t('Enter a new pair here. For local installations, you may enter localhost as a domain and it will be used.') . ($permission_to_update ? '' : t(' You do not have permission to edit the domain keys.')),


  );

  if ($permission_to_update) {

    $form['googlemap_domains_keys']['add_pair']['domain'] = array(
      '#type' => 'textfield',
      '#default_value' => '',
      '#title' => t('Domain'),
      '#field_suffix' => '<span id="domain-ok"><img src="' . $path_to_module . '/theme/cancel.png" alt="not ok" title="not ok" /></span>',
      /* Verify that the domain is valid */
      '#ahah' => array(
        'path' => 'geomap/admin/verify_domain',
        'wrapper' => 'domain-ok',
        'method' => 'replace',
        'effect' => 'fade',
        'event' => 'blur'
      ),


    );

    $form['googlemap_domains_keys']['add_pair']['key'] = array(
      '#type' => 'textfield',
      '#default_value' => '',
      '#title' => t('Google Maps API Key'),


    );

    $form['googlemap_domains_keys']['add_pair']['submit'] = array(
      '#type' => 'submit',
      '#value' => t('Add Domain Key'),


    );

    // For each node type, the following may be set
    // Icon, Shadow Icon, Transparent Icon, offset x, offset y, altitude (if present)
    if ($resultset = db_query("SELECT 'default' as name UNION SELECT name FROM {node_type} ORDER BY name")) {
      //load the DB table as well
      $geomap_icon_table = db_query('SELECT * FROM {geomap_nodetype_icon} ORDER BY type');
      $geomap_icon_array = array();
      while ($geomap_icon = db_fetch_object($geomap_icon_table)) {
        $geomap_icon_array[$geomap_icon->type] = $geomap_icon;
      }

      $form['node_settings'] = array(
        '#type' => 'fieldset',
        '#weight' => $group_weight++,
        '#collapsible' => TRUE,
        '#collapsed' => TRUE,
        '#title' => t('Icon Settings Per Node Type.'),
        '#description' => 'Leaving any value blank will load the default value for Google Maps. See ' . l('http://code.google.com/intl/en-US/apis/maps/documentation/javascript/v2/reference.html', 'http://code.google.com/intl/en-US/apis/maps/documentation/javascript/v2/reference.html', array(
          'fragment' => 'GIcon',
          'attributes' => array(
            'target' => '_blank'
          )
        )) . ' for information about icon settings.',
        '#tree' => TRUE,


      );

      while ($result = db_fetch_object($resultset)) {
        $form['node_settings'][$result->name] = array(
          '#type' => 'fieldset',
          '#weight' => $group_weight++,
          '#collapsible' => TRUE,
          '#collapsed' => TRUE,
          '#title' => t('!name settings', array(
            '!name' => ucfirst($result->name)
          )),


        );

        $form['node_settings'][$result->name]['icon'] = array(
          '#title' => t('Icon'),
          '#type' => 'textfield',
          '#weight' => $group_weight++,
          '#description' => 'http://',
          '#default_value' => (strlen($geomap_icon_array[$result->name]->icon) ? $geomap_icon_array[$result->name]->icon : ''),


        );

        $form['node_settings'][$result->name]['shadow'] = array(
          '#title' => t('Shadow Icon'),
          '#type' => 'textfield',
          '#weight' => $group_weight++,
          '#description' => 'http://',
          '#default_value' => (strlen($geomap_icon_array[$result->name]->shadow) ? $geomap_icon_array[$result->name]->shadow : ''),


        );

        $form['node_settings'][$result->name]['transparent'] = array(
          '#title' => t('Transparent Icon'),
          '#type' => 'textfield',
          '#weight' => $group_weight++,
          '#description' => 'http://',
          '#default_value' => (strlen($geomap_icon_array[$result->name]->transparent) ? $geomap_icon_array[$result->name]->transparent : ''),


        );

        $form['node_settings'][$result->name]['iconwidth'] = array(
          '#title' => t('Icon width'),
          '#type' => 'textfield',
          '#weight' => $group_weight++,
          '#default_value' => (int) $geomap_icon_array[$result->name]->iconwidth,


        );

        $form['node_settings'][$result->name]['iconheight'] = array(
          '#title' => t('Icon height'),
          '#type' => 'textfield',
          '#weight' => $group_weight++,
          '#default_value' => (int) $geomap_icon_array[$result->name]->iconheight,


        );

        $form['node_settings'][$result->name]['iconanchor_x'] = array(
          '#title' => t('Icon Anchor X'),
          '#type' => 'textfield',
          '#weight' => $group_weight++,
          '#default_value' => (int) $geomap_icon_array[$result->name]->iconanchor_x,


        );

        $form['node_settings'][$result->name]['iconanchor_y'] = array(
          '#title' => t('Icon Anchor Y'),
          '#type' => 'textfield',
          '#weight' => $group_weight++,
          '#default_value' => (int) $geomap_icon_array[$result->name]->iconanchor_y,


        );

        $form['node_settings'][$result->name]['iconaltitude_start'] = array(
          '#title' => t('Altitude Start'),
          '#description' => t('13 >= altitude_start >= altitude_stop >= 0. If both are set to 0, they will be displayed at every altitude.'),
          '#type' => 'textfield',
          '#weight' => $group_weight++,
          '#default_value' => (int) $geomap_icon_array[$result->name]->iconaltitude_start,


        );

        $form['node_settings'][$result->name]['iconaltitude_stop'] = array(
          '#title' => t('Altitude Stop'),
          '#description' => t('13 >= altitude_start >= altitude_stop >= 0. If both are set to 0, they will be displayed at every altitude.'),
          '#type' => 'textfield',
          '#weight' => $group_weight++,
          '#default_value' => (int) $geomap_icon_array[$result->name]->iconaltitude_stop,


        );

      }
    }

    if (module_exists('taxonomy')) {
      $form['taxonomy_settings'] = array(
        '#type' => 'fieldset',
        '#weight' => $group_weight++,
        '#collapsible' => TRUE,
        '#collapsed' => TRUE,
        '#title' => t('Icon Settings Per Taxonomy Term.'),
        '#description' => 'These settings will override the node type settings. If two terms are chosen for one node, then the taxomony weight system will determine the load order. Leaving any value blank will load the default value for Google Maps. See ' . l('http://code.google.com/intl/en-US/apis/maps/documentation/javascript/v2/reference.html', 'http://code.google.com/intl/en-US/apis/maps/documentation/javascript/v2/reference.html', array(
          'fragment' => 'GIcon',
          'attributes' => array(
            'target' => '_blank'
          )
        )) . ' for information about icon settings.',
        '#tree' => TRUE,


      );
      //In order to be able to edit this section, the user must have the right to administer taxonomy terms
      if (user_access('administer taxonomy')) {
        if ($resultset = db_query("SELECT t.tid as ttid, t.vid as vid, t.name as term, v.name as vocabulary, gti.* FROM {term_data} t JOIN {vocabulary} v ON t.vid = v.vid LEFT OUTER JOIN {geomap_taxonomy_icon} gti ON gti.tid = t.tid ORDER BY v.weight ASC, t.weight ASC, v.name ASC, t.name ASC;")) {
          while ($result = db_fetch_object($resultset)) {
            $form['taxonomy_settings'][$result->ttid] = array(
              '#type' => 'fieldset',
              '#weight' => $group_weight++,
              '#collapsible' => TRUE,
              '#collapsed' => TRUE,
              '#title' => t('!vocabulary :: !term settings', array(
                '!vocabulary' => strtoupper($result->vocabulary),
                '!term' => strtoupper($result->term),

              )),

            );

            $form['taxonomy_settings'][$result->ttid]['icon'] = array(
              '#title' => t('Icon'),
              '#type' => 'textfield',
              '#weight' => $group_weight++,
              '#description' => 'http://',
              '#default_value' => (strlen($result->icon) ? $result->icon : ''),


            );

            $form['taxonomy_settings'][$result->ttid]['shadow'] = array(
              '#title' => t('Shadow Icon'),
              '#type' => 'textfield',
              '#weight' => $group_weight++,
              '#description' => 'http://',
              '#default_value' => (strlen($result->shadow) ? $result->shadow : ''),

            );

            $form['taxonomy_settings'][$result->ttid]['transparent'] = array(
              '#title' => t('Transparent Icon'),
              '#type' => 'textfield',
              '#weight' => $group_weight++,
              '#description' => 'http://',
              '#default_value' => (strlen($result->transparent) ? $result->transparent : ''),

            );

            $form['taxonomy_settings'][$result->ttid]['iconwidth'] = array(
              '#title' => t('Icon width'),
              '#type' => 'textfield',
              '#weight' => $group_weight++,
              '#default_value' => (strlen($result->iconwidth) ? $result->iconwidth : ''),

            );

            $form['taxonomy_settings'][$result->ttid]['iconheight'] = array(
              '#title' => t('Icon height'),
              '#type' => 'textfield',
              '#weight' => $group_weight++,
              '#default_value' => (strlen($result->iconheight) ? $result->iconheight : ''),

            );

            $form['taxonomy_settings'][$result->ttid]['iconanchor_x'] = array(
              '#title' => t('Icon Anchor X'),
              '#type' => 'textfield',
              '#weight' => $group_weight++,
              '#default_value' => (strlen($result->iconanchor_x) ? $result->iconanchor_x : ''),

            );

            $form['taxonomy_settings'][$result->ttid]['iconanchor_y'] = array(
              '#title' => t('Icon Anchor Y'),
              '#type' => 'textfield',
              '#weight' => $group_weight++,
              '#default_value' => (strlen($result->iconanchor_y) ? $result->iconanchor_y : ''),

            );

            $form['taxonomy_settings'][$result->ttid]['iconaltitude_start'] = array(
              '#title' => t('Altitude Start'),
              '#description' => t('13 >= altitude_start >= altitude_stop >= 0. If both are set to 0, they will be displayed at every altitude.'),
              '#type' => 'textfield',
              '#weight' => $group_weight++,
              '#default_value' => (int) (strlen($result->iconaltitude_start) ? $result->iconaltitude_start : 0),


            );

            $form['taxonomy_settings'][$result->ttid]['iconaltitude_stop'] = array(
              '#title' => t('Altitude Stop'),
              '#description' => t('13 >= altitude_start >= altitude_stop >= 0. If both are set to 0, they will be displayed at every altitude.'),
              '#type' => 'textfield',
              '#weight' => $group_weight++,
              '#default_value' => (int) (strlen($result->iconaltitude_stop) ? $result->iconaltitude_stop : 0),


            );
          }
        }
      }
      else {
        $form['taxonomy_settings'] = array(
          '#value' => t('You must have Taxonomy administrative rights to alter this section.'),


        );
      }
    }

    $form['#validate'] = array(
      "geomap_admin_form_validate"
    );
    $form['#submit'] = array(
      "geomap_admin_form_submit"
    );
  }

  return system_settings_form($form);
}

function _get_domain_keys() {
  $rows = array();
  $headers = array(
    'Domain',
    'Keys',
    ''
  );

  $path_to_module = drupal_get_path('module', 'geomap');

  if ($resset = db_query('SELECT * FROM {geomap_googlemap_api_keys} ORDER BY domain ASC')) {
    while ($res = db_fetch_object($resset)) {
      $text = t('delete !domain key', array(
        '!domain' => $res->domain
      ));
      $rows[] = array(
        $res->domain,
        $res->google_map_key,
        l(theme('image', $path_to_module . '/theme/cancel.png', $text, $text), 'geomap/admin/delete_key/' . $res->domain, array(
          'html' => TRUE
        ))
      );
    }
  }

  if (!count($rows)) {
    $rows[] = array(
      t('Enter the first pair below'),
      "",
      ""
    );
  }

  return theme('table', $headers, $rows);
}

function geomap_admin_verify_domain() {
  $path_to_module = drupal_get_path('module', 'geomap');

  $domain = $_POST['domain'];
  $domain0 = '0' . $domain;
  if (strpos($domain0, 'www')) {
    $message = 'Do not include www';
    return drupal_json(array(
      'status' => TRUE,
      'data' => theme('image', $path_to_module . '/theme/cancel.png', $message, $message) . ' ' . $message
    ));
  }
  else if (strpos($domain0, 'http')) {
    $message = 'Do not include http';
    return drupal_json(array(
        'status' => TRUE,
        'data' => theme('image', $path_to_module . '/theme/cancel.png', $message, $message) . ' ' . $message
      ));
  }

  //determine if the domain is already set
  if (db_result(db_query("SELECT COUNT(*) FROM {geomap_googlemap_api_keys} WHERE domain = '%s'", $domain))) {
    $message = "The domain has already been set. Delete it to reset it's key";
    return drupal_json(array(
      'status' => TRUE,
      'data' => theme('image', $path_to_module . '/theme/cancel.png', $message, $message) . ' ' . $message
    ));
  }

  $message = 'ok';
  return drupal_json(array(
    'status' => TRUE,
    'data' => theme('image', $path_to_module . '/theme/accept.png', $message, $message)
  ));
}

function geomap_admin_add_domain_key() {
  $path_to_module = base_path() . drupal_get_path('module', 'geomap');
  return drupal_json(array(
    'status' => TRUE,
    'data' => '<img src="' . $path_to_module . '/theme/accept.png" alt="ok" title="ok" />'
  ));
}

function geomap_admin_form_validate($form, & $form_state) {
  switch ($form_state['values']['op']) {
    case 'Add Domain Key':
      //TODO: verify that the key is not already in the system
      //TODO: verify that the key is not 0 length
      //TODO: verify that the domain is properly formatted
      break;
    default:
      //TODO: verify that the altitude start and stop are properly set (13 >= start >= stop >= 0)
      break;
  }
}

function geomap_admin_form_submit($form, & $form_state) {
  switch ($form_state['values']['op']) {
    case 'Add Domain Key':
      //add the domain pair entered - validation has already been done that the domain is not present in the pair
      if (db_query("INSERT INTO {geomap_googlemap_api_keys} VALUES ('%s', '%s')", $form_state['values']['domain'], $form_state['values']['key'])) {
        watchdog('Geomap', 'Google Maps API Key successfully updated for domain ' . $form_state['values']['domain']);
        drupal_set_message('Google Maps API Key successfully updated', 'status');
      }
      else {
        watchdog('Geomap', 'Google Maps API Key failed to update (' . $form_state['values']['domain'] . ', ' . $form_state['values']['key'] . ')', null, WATCHDOG_ERROR);
        drupal_set_message('Google Maps API Key failed to update', 'error');
      }
      break;
    default:
      //default submit button is pressed, add the icon settings

      //Node Settings
      foreach ($form_state['values']['node_settings'] as $nodetype => $icon) {
        if (strlen($icon['icon'])) {
          //do not use a foreach loop as that can be subject to POST injection attack
          db_query("UPDATE {geomap_nodetype_icon} SET icon = '%s', shadow = '%s', transparent = '%s', iconwidth = %d, iconheight = %d, iconanchor_x = %d, iconanchor_y = %d, iconaltitude_start = 0, iconaltitude_stop = 0 WHERE type = '%s'", $icon['icon'], $icon['shadow'], $icon['transparent'], $icon['iconwidth'], $icon['iconheight'], $icon['iconanchor_x'], $icon['iconanchor_y'], $nodetype);
          if (!db_affected_rows()) {
            //do the insert
            if (!(db_query("INSERT INTO {geomap_nodetype_icon} (type, icon, shadow, transparent, iconwidth, iconheight, iconanchor_x, iconanchor_y) VALUES ('%s', '%s', '%s', '%s', %d, %d, %d, %d)", $nodetype, $icon['icon'], $icon['shadow'], $icon['transparent'], $icon['iconwidth'], $icon['iconheight'], $icon['iconanchor_x'], $icon['iconanchor_y']))) {
              drupal_set_message("Failed to save icon for " . $nodetype, 'error');
            }
          }
        }
        else {
          //delete all information for this nodetype in the table
          db_query("DELETE FROM {geomap_nodetype_icon} WHERE type = '%s'", $nodetype);
        }
      }

      //Taxonomy Term settings
      foreach ($form_state['values']['taxonomy_settings'] as $tid => $icon) {
        if (strlen($icon['icon'])) {
          //do not use a foreach loop as that can be subject to POST injection attack
          db_query("UPDATE {geomap_taxonomy_icon} SET icon = '%s', shadow = '%s', transparent = '%s', iconwidth = %d, iconheight = %d, iconanchor_x = %d, iconanchor_y = %d, iconaltitude_start = 0, iconaltitude_stop = 0 WHERE tid = %d", $icon['icon'], $icon['shadow'], $icon['transparent'], $icon['iconwidth'], $icon['iconheight'], $icon['iconanchor_x'], $icon['iconanchor_y'], $tid);
          if (!db_affected_rows()) {
            //do the insert
            if (!(db_query("INSERT INTO {geomap_taxonomy_icon} (tid, icon, shadow, transparent, iconwidth, iconheight, iconanchor_x, iconanchor_y) VALUES ('%s', '%s', '%s', '%s', %d, %d, %d, %d)", $tid, $icon['icon'], $icon['shadow'], $icon['transparent'], $icon['iconwidth'], $icon['iconheight'], $icon['iconanchor_x'], $icon['iconanchor_y']))) {
              drupal_set_message("Failed to save icon for " . $nodetype, 'error');
            }
          }
        }
        else {
          //delete all information for this nodetype in the table
          db_query("DELETE FROM {geomap_taxonomy_icon} WHERE tid = %d", $tid);
        }
      }
      break;
  }
}

function geomap_admin_delete_key($domain = '') {
  if (!(strlen($domain))) {
    drupal_set_message('Domain not specified; could not delete key.');
    drupal_goto('admin/settings/geomap');
    return;
  }

  if (db_query("DELETE FROM {geomap_googlemap_api_keys} WHERE domain = '%s'", $domain)) {
    drupal_set_message('Google Maps API Key deleted successfully for ' . $domain);
    drupal_goto('admin/settings/geomap');
    return;
  }

  drupal_set_message('Cannot delete domain key for ' . $domain);
  drupal_goto('admin/settings/geomap');
  return;

}

/**
 * Menu item callback for geomap/admin/hook_geomap
 * Allows other modules to return a view
 *
 * List possible hooks here:
 *
 * @author Jeremy Chinquist
 * @param $op
 *   operations: {get_view, get_node, get_nodes}
 * @param $nids
 *   required
 * @param $latitude_a
 *   required
 * @param $longitutde_a
 *   required
 * @param $latitude_b
 *   optional
 * @param $longitude_b
 *   optional
 * @return json
 *   array of HTML arrays
 *
 */
function geomap_admin_hook_geomap($op = 'update_view', $nids = array(), $latitude_a = NULL, $longitude_a = NULL, $latitude_b = NULL, $longitude_b = NULL) {
  //this callback simply invokes the hook and returns.
  //functions impleming hook_geomap must NOT return a JSON encoded object. That will be encoded here.

  //if any are not sent, return an error
  if (!count($nids) || !is_array($nids) || $latitude_a === null || $longitude_a === null) {
    return drupal_to_js(array(
      'error' => 'Missing arguments'
    ));
  }

  $return = module_invoke_all('geomap', filter_xss($op), $nids, (float) $latitude_a, (float) $longitude_a, (float) $latitude_b, (float) $longitude_b);

  //$return is already an array of "hopefully" html & microformat elements
  return drupal_to_js($return);
}

/**
 * helper function to render the administration override display
 */
function _geomap_render_override_admin_display() {
  $path_to_module = drupal_get_path('module', 'geomap');

  $alt_text = array(
    'overridden' => t('File overridden'),
    'notoverridden' => t('File not overridden'),


  );

  //custom is currently a list. Check that we have overridden the following
  $check_for_files = array(
    'geomap.css',
    'Clusterer2.js',
    'jquery.googlemaps.js'
  );
  $custom = _geomap_get_customisations($path_to_module . '/custom');

  $counter = 1;
  $rows = array();

  foreach ($check_for_files as $file) {
    if ($custom[$file]) {
      $rows[] = array(
        $counter++ . '. ' . $file,
        theme('image', $path_to_module . '/theme/accept.png', $alt_text['overridden'], $alt_text['overridden']) . ' ' . $alt_text['overridden']
      );
    }
    else {
      $rows[] = array(
        $counter++ . '. ' . $file,
        theme('image', $path_to_module . '/theme/cancel.png', $alt_text['notoverridden'], $alt_text['notoverridden']) . ' ' . $alt_text['notoverridden']
      );
    }
  }

  return theme('table', array(
    'File Name',
    'Custom File'
  ), $rows);
}
